; File    : ENTBYL.lsp
; Datum   : 24.06.1991, 25.02.1992
; Von     : G.Mester
; Wozu    : Umwandlung Farben/Linientypen in Farben/Linientypen der Layers
; Aufruf  : ENTBYL
; Beispiel: -
; Returns : -
; Globals : -
; Modulvar: -
; Params  : -
; Locals  : ss . . . Selectionset
;           sl . . . Selectionset length
;           si . . . Selectionset Index
;           en . . . Entity
;           el . . . Entitylist
;           la . . . Layername
;           lt . . . Linetype
;           co . . . Color
;           laty . . Layer-Linetype
;           laco . . Layer-Color

(defun C:entbyl ( / ss sl si entyp en el la lt co laty laco)
;(defun C:sl2 ()
  (prompt (strcat "\n\e[7;1;40;32mENTBYL\e[mayer        "
                  "                                  Mester 25.02.92\e[m\n"))
  (princ "\nBYLAYER-Farben/Linientypen werden in Farben/Linientypen der Layers umgewandelt")   ; Info
  (princ "\nPress any key to continue or <ESC> to exit . . .")
  (if (equal (grread) (list 2 27)) (quit))           ; Warte auf OK oder ESC
  (princ "\nSelecting . . . ")                       ; Meldung
  (setq ocmdecho (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (cond
    ( (setq ss (ssget "x"))                          ; alle Elemente whlen
      (setq sl (sslength ss)                         ; Selectionsetlnge
            si 0                                     ; Selectionset Index = 0
      )
      (princ sl) (princ " found.")                   ; Meldung gefunden
;     (princ "\nProcessing      \e[s")               ; zur Benutzerunterhaltung
      (repeat sl                                     ; Anzahl gefunden mal
        (setq el (entget (setq en (ssname ss si))))  ; Entitywerte holen
        (setq entyp (cdr (assoc 0 el)))              ; Entitytype
        (setq si (1+ si))                            ; Increment Index
;       (princ "\e[u") (princ si)                    ; zur Benutzerunterhaltung

        (setq flg T)
        (if (= entyp "VIEWPORT") (setq flg nil) )
      (if flg
      (progn
        (setq la                                     ; Layer holen
          (if (assoc 8 el)
              (cdr (assoc 8 el))
          )
        )
        (setq laprop (tblsearch "layer" la))
        (setq laty (cdr (assoc '6  laprop))
              laco (cdr (assoc '62 laprop))
        )
        (if (minusp laco) (setq laco (* laco -1)))

        (setq co                                     ; Farbe holen
          (if (assoc 62 el)
              (cdr (assoc 62 el))
               laco
          )
        )
        (if (minusp co) (setq co (* co -1)))
        (setq lt                                     ; Linetype holen
           (if (assoc 6 el)
               (cdr (assoc 6 el))
               laty
           )
        )
        (if (= co 0) (setq co "BYBLOCK"))                 ; wenn bylock
        (if (= lt 0) (setq lt "BYBLOCK"))                 ; wenn bylock
        (command "_change" en "" "_P" "_c" co "_lt" lt "")
      )
      )
      )  
    )
    ('T (princ "\nKeine Elemente gefunden."))
  )
  (setvar "cmdecho" ocmdecho)
  (princ)
)
